#pragma once
#include <iostream>
#include "exception.h"
#include <time.h>
#include "Vector.h"
class Vector;
class CSLRMatrix {

private:

    double* adiag;
    double* altr;
    double* jptr;
    double* iptr;
    friend class Vector;
public:

    CSLRMatrix(double* p_adiag, double* p_altr, double* p_jptr, double* p_iptr);
    CSLRMatrix(const CSLRMatrix& p_mat);
    ~CSLRMatrix();


    friend std::istream& operator>>(std::istream& is, CSLRMatrix& m);
    friend std::ostream& operator<<(std::ostream& os, const CSLRMatrix& mat);

    int matsize() const;
    int nzn() const;

    const CSLRMatrix& operator=(const CSLRMatrix& m);

    friend Vector operator*(const CSLRMatrix& mat, const Vector& v);
    friend CSLRMatrix operator*(double scalar, const CSLRMatrix& m);
    friend CSLRMatrix operator*(const CSLRMatrix& m, double scalar);

};
