#pragma once
#include <cstdint>
#include <iostream>
#include <exception>
#include "Matrix.h"
class CSLRMatrix;
class Vector
{

public:

	Vector(int n = 0, double value = 0.0);

	Vector(const Vector& v);

	~Vector();

	double& operator[](int index);

	const double& operator[](int index) const;

	Vector& operator=(const Vector& v);

	Vector& operator+=(const Vector& v);
	Vector& operator-=(const Vector& v);

	Vector operator+() const;
	Vector operator-() const;

	friend Vector operator+(const Vector& v1, const Vector& v2);
	friend Vector operator-(const Vector& v1, const Vector& v2);

	friend double operator*(const Vector& v1, const Vector& v2);
	friend Vector operator*(const Vector& v, double scalar);
	friend Vector operator*(double scalar, const Vector& v);

	//friend Vector operator*(const CSLRMatrix& m, const Vector& v);



	friend std::ostream& operator<<(std::ostream& os, const Vector& v);
	friend std::istream& operator>>(std::istream& is, Vector& v);

	operator double* ();

	double length() const;
	int dimension() const;

private:
	int size;
	double* data;
	friend class CSLRMatrix;
};






